//(BuildMod) VER 1.3.0.0 (1.3) By Xatt1c.
//Thanks Marcus_Brown001 for the prop spawning system + the list + the owner system + the prop count system.
//Thanks alot Marcus.
#include <sourcemod>
#include <sdktools>
#include <morecolors>
#include <buildmod>
#include <geoip>

#define NAME "(BuildMod)"
#define AUTHOR "Xatt1c"
#define DESC "Various commands used for build/cheat servers."
#define VER "1.3.0.0"
#define URL ""
#define MAX_CONFIG_PROPS 640
#define MAX_ENTITIES 2048
#define HUDTICK	0.1

new Props;
new PropLimit;
new PropCount[MAXPLAYERS + 1];
new Owner[MAX_ENTITIES + 1];

new String:sPropType[MAX_CONFIG_PROPS][64];
new String:sPropSpawnNames[MAX_CONFIG_PROPS][64];
new String:sPropDisplayNames[MAX_CONFIG_PROPS][64];
new String:sPropPaths[MAX_CONFIG_PROPS][PLATFORM_MAX_PATH];
new String:clientInfo[256];

new bool:PropHUDOn[MAXPLAYERS + 1];

public Plugin:myinfo = 
{
	name = NAME,
	author = AUTHOR,
	description = DESC,
	version = VER,
	url = URL
}

public OnClientPutInServer(client)
{
	decl String:AuthID[64], String:IP[64];
	GetClientAuthString(client, AuthID, sizeof(AuthID));
	GetClientIP(client, IP, sizeof(IP));
	BuildPath(Path_SM, clientInfo, sizeof(clientInfo), "data/buildmod/logs/%N.txt", client);
	LogToFile(clientInfo, "Username: %N | SteamID: %s | IP: %s", client, AuthID, IP);
	PropCount[client] = 0;
	CreateTimer(0.1, PropHUD, client, TIMER_REPEAT);
	PropHUDOn[client] = true;
}

public Action:PropHUD(Handle:timer, any:client)
{
	decl String:PropName[256];
	if(IsClientInGame(client) && IsClientConnected(client) && PropHUDOn[client])
	{
		SetHudTextParams(0.001, -50.0, HUDTICK, 200, 150, 0, 255, 0, 6.0, 0.1, 0.2);
		new entity = GetClientAimTarget(client, false);
		if (GetClientAimTarget(client, false) == -1)
		{
			ShowHudText(client, -1, "Prop Count: [%d/%d]", PropCount[client], PropLimit);
		}else{
			GetEntityClassname(entity, PropName, sizeof(PropName));
			if(StrEqual(PropName, "player", true))
			{
				ShowHudText(client, -1, "Prop Count: [%d/%d]", PropCount[client], PropLimit);
			}else{
				if(CheckOwner(client, entity))
				{
					ShowHudText(client, -1, "Prop Count: [%d/%d] \nProp: %s", PropCount[client], PropLimit, PropName);
				}else{
					ShowHudText(client, -1, "Owner: %N \nProp: %s", Owner[entity], PropName);
				}
			}
		}
	}else{
		//No code is needed here.
	}
}

public Native_DissolveEntity(Handle:plugin, numParams)
{	
	new entity = GetNativeCell(1);
	decl String:targetname[128];
	
	Format(targetname, sizeof(targetname), "dissolvetarget%f%f", GetGameTime(), GetRandomFloat());
	DispatchKeyValue(entity, "targetname", targetname);
	
	new dissolver = CreateEntityByName("env_entity_dissolver");
	
	DispatchKeyValue(dissolver, "dissolvetype", "3");
	DispatchKeyValue(dissolver, "target", targetname);
	AcceptEntityInput(dissolver, "Dissolve");
	PropCount[Owner[entity]] -= 1;
	AcceptEntityInput(dissolver, "Kill");
}

stock Load_Props() //Thanks to Marcus for the prop spawning system. :) + The prop spawn list :D
{
	decl String:sPath[PLATFORM_MAX_PATH];
	BuildPath(Path_SM, sPath, PLATFORM_MAX_PATH, "data/buildmod/spawn.ini");
	
	new Handle:hKeyValue = CreateKeyValues("Props");
	if (FileToKeyValues(hKeyValue, sPath))
	{
		Props = 0;
		
		KvGotoFirstSubKey(hKeyValue);
		do
		{
			KvGetString(hKeyValue, "display_name", sPropDisplayNames[Props], sizeof(sPropDisplayNames));
			KvGetString(hKeyValue, "spawn_name", sPropSpawnNames[Props], sizeof(sPropSpawnNames));
			
			KvGetString(hKeyValue, "path", sPropPaths[Props], PLATFORM_MAX_PATH);
			KvGetString(hKeyValue, "type", sPropType[Props], sizeof(sPropType));
			
			PrecacheModel(sPropPaths[Props]);
			Props++;
		}
		while (KvGotoNextKey(hKeyValue));
		CloseHandle(hKeyValue);
		
		PrintToServer("%s: Loaded %d props", NAME, Props);
	}
}

public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{
	CreateNative("SpawnEntity", Native_SpawnEntity);
	CreateNative("DissolveEntity", Native_DissolveEntity);
	return APLRes_Success;
}

stock GetCollisionPoint(client, Float:pos[3]) //Also thanks to marcus for this.
{
	decl Float:vOrigin[3], Float:vAngles[3];
	
	GetClientEyePosition(client, vOrigin);
	GetClientEyeAngles(client, vAngles);
	
	new Handle:trace = TR_TraceRayFilterEx(vOrigin, vAngles, MASK_SOLID, RayType_Infinite, TraceEntityFilterPlayer);
	
	if(TR_DidHit(trace))
	{
		TR_GetEndPosition(pos, trace);
		CloseHandle(trace);
		
		return;
	}
	
	CloseHandle(trace);
}

public bool:TraceEntityFilterPlayer(entity, contentsMask)
{
	return entity > MaxClients;
} 

public Native_SpawnEntity(Handle:plugin, numParams)
{	
	new client = GetNativeCell(1);
	new len;
	new len2;
	new propname;
	GetNativeStringLength(2, len);
	GetNativeStringLength(3, len2);
	GetNativeStringLength(4, propname);
	new String:sModel[len+1], String:sType[len2+1], String:sProp[propname+1];
	GetNativeString(2, sModel, len+1);
	GetNativeString(3, sType, len2+1);
	GetNativeString(4, sProp, propname+1);
	decl Float:origin[3], Float:angles[3];
	new prop = CreateEntityByName(sType);
	PrecacheModel(sModel);
	DispatchKeyValue(prop, "model", sModel);
	DispatchKeyValue(prop, "classname", sProp);
	GetCollisionPoint(client, origin);
	GetClientAbsAngles(client, angles);
	DispatchSpawn(prop);
	TeleportEntity(prop, origin, angles, NULL_VECTOR);
	SetOwner(client, prop);
	SetEntProp(prop, Prop_Data, "m_takedamage", 0, 1);
	PropCount[client]++;
}

public OnPluginStart()
{
	LoadTranslations("common.phrases");
	Load_Props();
	RegConsoleCmd("sm_spawn", Command_Spawn, "Spawns a prop by alias.");
	RegConsoleCmd("sm_delete", Command_Delete, "Removes a prop.");
	RegConsoleCmd("sm_give", Command_GiveProp, "Gives a prop to another player.");
	RegConsoleCmd("sm_propinfo", Command_PropInfo, "Gives info about a prop.");
	RegConsoleCmd("sm_freeze", Command_Freeze, "Disables motion on the prop you are looking at.");
	RegConsoleCmd("sm_unfreeze", Command_UnFreeze, "Enables motion on the prop you are looking at.");
	RegConsoleCmd("sm_clientinfo", Command_ClientInfo, "Gives info about the client.");
	RegConsoleCmd("sm_hud", Command_Hud, "Toggles the hud on & off.");
	RegConsoleCmd("sm_rotate", Command_Rotate, "Rotates an entity.");
	RegAdminCmd("sm_setowner", Command_SetOwner, ADMFLAG_SLAY, "Sets the owner of a prop.");
	PrintToServer("%s: Loaded %s", NAME, NAME);
	PropLimit = 350;
}

public OnClientDisconnect(client)
{
	for (new i = 0; i <= GetMaxEntities(); i++)
	{
		if (Owner[i] == client)
		{
			DissolveEntity(i);
		}
	}
	PropHUDOn[client] = false;
}

Msg(client, String:message[])
{
	CPrintToChat(client, "{blue}%s{default} %s", NAME, message);
}

NotYours(client)
{
	Msg(client, "That prop doesn't belong to you.");
}

LookingAt(client)
{
	Msg(client, "You are not looking at anything.");
}

PropChange(client, target, entity)
{
	decl String:NewOwner[502];
	Format(NewOwner, sizeof(NewOwner), "You have recieved prop %d from %N.", entity, client);
	Msg(target, NewOwner);
}

CantSpawn(client, String:propname[])
{
	decl String:PropMsg[128];
	Format(PropMsg, sizeof(PropMsg), "You can't spawn the prop '{green}%s{default}'.", propname);
	Msg(client, PropMsg);
}

public Action:Command_Spawn(client, args)
{
	if(args < 1)
	{
		ReplyToCommand(client, "%s - sm_spawn <prop alias>", NAME);
		return Plugin_Handled;
	}
	if (PropCount[client] >= PropLimit)
	{
		Msg(client, "You cannot spawn anymore props.");
		return Plugin_Handled;
	}
	decl String:propAlias[128];
	GetCmdArg(1, propAlias, sizeof(propAlias));
	for (new i; i < Props; i++)
	{
		if(StrEqual(propAlias, "axis", true))
		{
			CantSpawn(client, "axis");
			return Plugin_Handled;
		}
		if(StrEqual(propAlias, "chess", true))
		{
			CantSpawn(client, "chess");
			return Plugin_Handled;
		}
		if(StrEqual(propAlias, "cleaver", true))
		{
			CantSpawn(client, "cleaver");
			return Plugin_Handled;
		}
		if(StrEqual(propAlias, "alyx", true))
		{
			Msg(client, "Spawning '{green}alyx{default}' has been disabled due to server crashes.");
			return Plugin_Handled;
		}
		if(StrEqual(propAlias, "weaponstripper", true))
		{
			CantSpawn(client, "weaponstripper");
			return Plugin_Handled;
		}
		if(StrEqual(propAlias, "traintrack1", true))
		{
			CantSpawn(client, "traintrack1");
			return Plugin_Handled;
		}
		if(StrEqual(propAlias, "traintrack2", true))
		{
			CantSpawn(client, "traintrack2");
			return Plugin_Handled;
		}
		if(StrEqual(propAlias, "traintrack3", true))
		{
			CantSpawn(client, "traintrack3");
			return Plugin_Handled;
		}
		if(StrEqual(propAlias, sPropSpawnNames[i], true))
		{
			SpawnEntity(client, sPropPaths[i], sPropType[i], sPropDisplayNames[i]);
		}
	}
	return Plugin_Handled;
}

public Action:Command_Delete(client, args)
{
	new ent = GetClientAimTarget(client, false);
	decl String:Option[32];
	GetCmdArg(1, Option, sizeof(Option));
	if(StrEqual(Option, "all", true))
	{
		for (new i = 0; i <= GetMaxEntities(); i++)
		{
			if (Owner[i] == client)
			{
				DissolveEntity(i);
			}
		}
	}else{
		if (GetClientAimTarget(client, false) == -1)
		{
			LookingAt(client);
			return Plugin_Handled;
		}
		if(CheckOwner(client, ent))
		{
			DissolveEntity(ent);
			Msg(client, "Your prop has been removed.");
		}else{
			NotYours(client);
		}
	}
	return Plugin_Handled;
}

public Action:Command_SetOwner(client, args)
{
	if (GetClientAimTarget(client, false) == -1)
	{
		LookingAt(client);
		return Plugin_Handled;
	}
	if(args < 1)
	{
		ReplyToCommand(client, "%s - sm_setowner <target>", NAME);
		return Plugin_Handled;
	}
	decl String:TargetClient[256];
	GetCmdArg(1, TargetClient, sizeof(TargetClient)); 
	new ent = GetClientAimTarget(client, false);
	new target = FindTarget(client, TargetClient, true, false);
	SetOwner(target, ent);
	PropChange(client, target, ent);
	return Plugin_Handled;
}

public Action:Command_GiveProp(client, args)
{
	if (GetClientAimTarget(client, false) == -1)
	{
		LookingAt(client);
		return Plugin_Handled;
	}
	if(args < 1)
	{
		ReplyToCommand(client, "%s - sm_give <target>", NAME);
		return Plugin_Handled;
	}
	new ent = GetClientAimTarget(client, false);
	decl String:TargetClient[256];
	GetCmdArg(1, TargetClient, sizeof(TargetClient)); 
	GiveProp(client, ent, TargetClient);
	return Plugin_Handled;
}

public Action:Command_PropInfo(client, args)
{
	if (GetClientAimTarget(client, false) == -1)
	{
		LookingAt(client);
		return Plugin_Handled;
	}
	new ent = GetClientAimTarget(client, false);
	decl String:ModelName[128], String:PropName[256];
	GetEntPropString(ent, Prop_Data, "m_ModelName", ModelName, sizeof(ModelName));
	GetEntityClassname(ent, PropName, sizeof(PropName));
	if(CheckOwner(client, ent))
	{
		CPrintToChat(client, "Model: {olive}%s{default}", ModelName);
		CPrintToChat(client, "Owner: {olive}%N{default} ({olive}You{default})", Owner[ent]);
		CPrintToChat(client, "Prop name: {olive}%s{default}", PropName);
	}else{
		CPrintToChat(client, "Model: {olive}%s{default}", ModelName);
		CPrintToChat(client, "Owner: {olive}%N{default}", Owner[ent]);
		CPrintToChat(client, "Prop name: {olive}%s{default}", PropName);
	}
	return Plugin_Handled;
}

public Action:Command_Freeze(client, args)
{
	
	if (GetClientAimTarget(client, false) == -1)
	{
		LookingAt(client);
		return Plugin_Handled;
	}
	new ent = GetClientAimTarget(client, false);
	if(CheckOwner(client, ent))
	{
		AcceptEntityInput(ent, "disablemotion");
	}else{
		NotYours(client);
	}
	return Plugin_Handled;
}

public Action:Command_UnFreeze(client, args)
{
	if (GetClientAimTarget(client, false) == -1)
	{
		LookingAt(client);
		return Plugin_Handled;
	}
	new ent = GetClientAimTarget(client, false);
	if(CheckOwner(client, ent))
	{
		AcceptEntityInput(ent, "enablemotion");
	}else{
		NotYours(client);
	}
	return Plugin_Handled;
}

public Action:Command_ClientInfo(client, args)
{
	decl String:AuthID[64], String:IP[64];
	GetClientAuthString(client, AuthID, sizeof(AuthID));
	GetClientIP(client, IP, sizeof(IP));
	CPrintToChat(client, "Name: {olive}%N{default}", client);
	CPrintToChat(client, "Steam ID: {olive}%s{default}", AuthID);
	CPrintToChat(client, "IP: {olive}%s{default}", IP);
	CPrintToChat(client, "Prop Count: {olive}[%d/%d]{default}", PropCount[client], PropLimit);
	CPrintToChat(client, "Deaths: {olive}%d{default}", GetClientDeaths(client));
	return Plugin_Handled;
}

public Action:Command_Hud(client, args)
{
	if(args < 1)
	{
		ReplyToCommand(client, "%s - sm_hud <on or off>", NAME);
		return Plugin_Handled;
	}
	decl String:option[64];
	GetCmdArg(1, option, sizeof(option));
	if(StrEqual(option, "on", true))
	{
		PropHUDOn[client] = true;
	}else if(StrEqual(option, "off", true))
	{
		PropHUDOn[client] = false;
	}else{
		ReplyToCommand(client, "%s - sm_hud <on or off>", NAME);
	}
	return Plugin_Handled;
}

public Action:Command_Rotate(client, args)
{
	if (GetClientAimTarget(client, false) == -1)
	{
		LookingAt(client);
		return Plugin_Handled;
	}
	if(args < 1)
	{
		ReplyToCommand(client, "%s - sm_rotate <int>", NAME);
		return Plugin_Handled;
	}
	new entity = GetClientAimTarget(client, false);
	decl String:int[16];
	decl Float:angles[3], Float:angles2[3];
	GetCmdArg(1, int, sizeof(int));
	new intangles = StringToInt(int);
	GetEntPropVector(entity, Prop_Send, "m_angRotation", angles);
	angles2[1] = (angles[1] += intangles);
	if(CheckOwner(client, entity))
	{
		TeleportEntity(entity, NULL_VECTOR, angles2, NULL_VECTOR);
		Msg(client, "Your prop has been rotated.");
	}else{
		NotYours(client);
	}
	return Plugin_Handled;
}

CheckOwner(client, entity)
{
	if(Owner[entity] == client)
	{
		return true;
	}
	return false;
}

SetOwner(client, entity)
{
	Owner[entity] = client;
}

GiveProp(client, entity, String:NewOwner[])
{
	new target = FindTarget(client, NewOwner, true, false);
	if(CheckOwner(client, entity))
	{
		SetOwner(target, entity);
		PropChange(client, target, entity);
		PropCount[Owner[entity]] -= 1;
		PropCount[target]++;
	}else{
		NotYours(client);
	}
}
